<?php
/*
Plugin Name: Digg Implementor
Version: 0.3
Plugin URI: http://ottodestruct.com
Author:  Otto
Author URI: http://ottodestruct.com
Description: Adds the digg JavaScript button to your post if its been submitted to the social bookmarking site digg (a modification of the original by http://www.bill2me.com)
*/ 


/*

You can include an optional custom meta value in a post 
called "DiggTopic" with the topic that the submit button 
will send to digg. Whoever diggs your story can still change it, 
but likely won't.

This is the list of allowable values:

apple
tech_deals
gaming_news
hardware
linux_unix
mods
movies
music
software
tech_news
security
design
general_sciences
programming
gadgets
business_finance
politics
world_news
offbeat_news
celebrity
television
playable_web_games
space
environment
health
videos_animation
videos_comedy
videos_educational
videos_music
videos_people
videos_gaming

*/

function check_for_wjt()
{
	// check to see if the other digg implementor is loaded. If not, then create this function for backwards compatibility
	if (!function_exists('wjt_diggImp')) {
		function wjt_diggImp($show_digg_submit_button = true, $submit_button_graphic = "55x55-digg-box.png")
		{
			diggImp($show_digg_submit_button, $submit_button_graphic);
		}
	}
}

// let other plugins load before checking for wjt's plugin
add_action('plugins_loaded', 'check_for_wjt');

function diggImp($show_digg_submit_button = true, $submit_button_graphic = "55x55-digg-box.png")
{
	global $id;
	
	$digg_link = get_post_meta($id, 'DiggUrl', true);

	// now that we have the digg_link, show the code
	if (substr_count(strtolower($digg_link),"digg.com") >0 ) // double check that our digg link is a real digg.com link
  	{
  		echo '<div class="diggButton">';
		echo '<script> digg_url ="'.$digg_link.'" </script>';
		echo '<script src="http://digg.com/api/diggthis.js"></script>';
		echo '</div>';
  	}
  	
  	// show the submit graphic to let people submit the post themselves, if they want
  	else if ($show_digg_submit_button)
  	{
  		$diggImageDir = get_settings('siteurl').'/wp-content/plugins/digg/badges/';
  	
  		echo '<div class="diggButton">';
  		
  		$diggTopic = get_post_meta($id,'DiggTopic',true);
  		
  		$diggSubmitURL = "http://digg.com/submit?phase=2";
  		$diggSubmitURL .= "&url=" . urlencode(get_permalink());
  		$diggSubmitURL .= "&title=" . urlencode(substr(get_the_title(),0,75));
  		$diggSubmitURL .= "&bodytext=" . urlencode(substr(get_the_content(),0,340));
  		if ($diggTopic != '') $diggSubmitURL .= "&topic=" . $diggTopic;

		
  		echo '<a href="'.$diggSubmitURL.'">';
  		echo '<img src="'.$diggImageDir.$submit_button_graphic.'" />';
  		echo '</a>';
  	
  		echo '</div>';
  	}
}


// the loop hook will find the presence of incoming digg links
function digg_loop_hook()
{
	global $id;
	
	// sanity checks for speed
	if (!is_single() || $id ==0 ) return;
	
	// get the existing link, if any
	$digg_link = get_post_meta($id, 'DiggUrl', true);
	
	// get the referer
   	$refererURL = $_SERVER['HTTP_REFERER'];
	$ref= strtolower($refererURL);

	// checks the to see if the referer is the digg server
	if ( $digg_link == '' 				// check to see if we have already seen the URL once before
		&& substr_count($ref, "_") > 0   	// poor man's way of ensuring that the referrer is an actual story link and not just the index or something
		&& strpos($ref, "digg.com") !== false 	// make sure that digg.com is in the referrer string at all
		&& strpos($ref, "?") == false		// make sure that it's not a GET type of thing
		&&
		(strpos($ref, "digg.com")==0 || 	// make sure that the referrer starts with something normal
		strpos($ref, "http://digg.com")==0 ||
		strpos($ref, "www.digg.com")==0 ||
		strpos($ref, "http://www.digg.com")==0)
		)
	{
		$digg_link=$refererURL;				// set our digg link url
		add_post_meta($id, 'DiggUrl', $refererURL);	// save it for future usage
	}
}

add_action('loop_start','digg_loop_hook');

?>
